
#ifndef _BRUTE_FORCE_H
#define _BRUTE_FORCE_H
//Extrapolate single core running times for brute force algorithm.
void  brute_force_extrapolate(DataSet* data,unsigned long bf_N, int k) {
    float time_diff=0;
    float extrap_run_time=0;
    int hours;
    unsigned long num_dist=0;
    FLOAT _dist;
    float all_dist = (data->size*(data->size -1.0))/2.0;
    float t=0;

    printf("bf_N:%llu\n",bf_N);
    if(bf_N == -1) {exit(1);}
    kNNGraph* kNN = init_kNNGraph(data->size,k);

    g_timer.tick();
    g_timer.tuck("Extrapolate brute force single core running time");
    bf_N = bf_N*1000;
    if(bf_N > (unsigned long)((data->size)*(data->size -1)*0.4)) {
        bf_N=(unsigned long)((data->size)*(data->size -1)*0.4);
    }
    printf("bf_N:%llu\n",bf_N);
    fflush(stdout);

    /*return NULL;*/
    for(int data_i = 0; data_i < data->size - 1; data_i++) {
        set_kNN_id(kNN, data_i, data_i);
        for(int data_j = data_i+1; data_j < data->size; data_j++) {
            _dist = distance(data,data_i,data_j);
            updatekNN(kNN,data_i,data_j,_dist);
            updatekNN(kNN,data_j,data_i,_dist);
            num_dist++;
            /*if(num_dist > bf_N) {goto out_of_double_for;}*/
            if(num_dist > bf_N) {break;}
        }
        if(num_dist > bf_N) {break;}

    }

    time_diff = g_timer.tuck("TIME");
    extrap_run_time = time_diff*(all_dist/((float)bf_N));
    hours = extrap_run_time/(60*60);
    printf("TIME: %f Extrapolated run time: %f ( %d hours) ndist:%d \n",time_diff,extrap_run_time,hours,num_dist);
    fflush(stdout);

    // 1% recall
    t= extrap_run_time/100;
    hours = t/(60*60);
    printf("RECALL: %f Extrapolated run time: %f ( %d hours) \n",1/100.0,t,hours);

    // 10%-100% recall
    for(int i=1; i<=10; i++) {
        t= extrap_run_time/10*i;
        hours = t/(60*60);
        printf("RECALL: %f Extrapolated run time: %f ( %d hours) \n",i/10.0,t,hours);
    }
    return;
}

// Construct exact kNN graph by brute force search.
kNNGraph* brute_force_search (DataSet* data,int bf_N, int k) {

    if(bf_N == -1) {bf_N = data->size;}
    kNNGraph* kNN = init_kNNGraph(bf_N,k);

    printf("Staring brute force search (FULL)\n");

#if defined(_OPENMP)
omp_set_num_threads(g_options.num_threads);
#pragma omp parallel for default(shared)
#endif
    for(int data_i = 0; data_i < bf_N; data_i++) {
        if(data_i % 10 == 0) { printf("BRUTe FORCE %i/%i/%i\n",data_i,bf_N,data->size);}
        /*for(int data_j = data_i+1; data_j < data->size; data_j++) {*/
        set_kNN_id(kNN, data_i, data_i);
        /*for(int data_j = data_i+1; data_j < data->size; data_j++) {*/
        for(int data_j = 0; data_j < data->size; data_j++) {
            if(data_i == data_j){ continue;}
            /*FLOAT* v = get_vector(data,data_i);*/
            /*coord += *(v + i_dim2) * pm[data->dimensionality*i_dim+i_dim2];*/
            FLOAT _dist = distance(data,data_i,data_j);
            /*#pragma omp critical(dataupdate)*/
            {
                updatekNN(kNN,data_i,data_j,_dist);
                /*if(data_j < bf_N) {*/
                /*updatekNN(kNN,data_j,data_i,_dist);*/
                /*}*/
                /*update(kNN, data, data_i, data_j);*/
            }
        }
    }
    return kNN;
}

#endif
