

// (Experimental)
// Constructing z-order for points, without calculation of actual z-values,
// based on just comparing the first n bits needed to determine order.

    struct z_compare
    {

    DataSet* DS;
    vector<float>* rand_vector;
    vector<int> dimension_permutation;
    float precision;
    int z_dimensions;
    float elem_min;
    float elem_max;

    bool operator()(int p1_i, int p2_i) const
    {


        /*float precision = 2147483647/128;*/
        FLOAT* p1f = get_vector(DS,p1_i);
        FLOAT* p2f = get_vector(DS,p2_i);
        UINT msb = 0;
        UINT curmsb = 0;
        int maxxor_i = -1;
        int dimensionality = DS->dimensionality;
        bool lt = false;
        /*float min_value = 80;*/

        unsigned int P1[z_dimensions];
        unsigned int P2[z_dimensions];

        project_SJS(DS,p1f,P1,z_dimensions,*rand_vector,dimension_permutation,DS->elem_min,
                DS->elem_max, precision);
        project_SJS(DS,p2f,P2,z_dimensions,*rand_vector,dimension_permutation,DS->elem_min,
                DS->elem_max, precision);

        dimensionality = z_dimensions;


        for(int i_dim = 0; i_dim < dimensionality ; i_dim++) {

            unsigned int p1 = P1[i_dim];
            unsigned int p2 = P2[i_dim];

            // Calculates the index of most significant differing bit
            // clzl: Returns the number of leading 0-bits
            // https://gcc.gnu.org/onlinedocs/gcc-4.4.2/gcc/Other-Builtins.html
            curmsb = 32 - __builtin_clzl(p1^p2);

            if(msb < curmsb ) {
                msb = curmsb;
                /*maxxor_i = i_dim;*/
                maxxor_i = i_dim;
            }
        }

        lt = P1[maxxor_i] > P2[maxxor_i];
        return lt;
    }
};




void  generate_z_index_sortv
(DataSet* data, int z_dimensions, int * zindex_out, float precision)
{
    vector<float> rand_vector(data->dimensionality);
    vector<int> dimension_permutation(data->dimensionality);
    /*vector<int> point_on_curve(data->size);*/

    vector<int> zindex(data->size);
    for (int data_i = 0; data_i < data->size; data_i++) {
        zindex[data_i] = data_i;
    }


    for(int j = 0; j < data->dimensionality; j++ ) {
        dimension_permutation[j] = j;
    }

        for(int i_dim =0; i_dim < data->dimensionality; i_dim++) {
            rand_vector[i_dim] = RAND_FLOAT();
            if(rand_vector[i_dim] > 1 || rand_vector[i_dim] < 0){ terminal_error("rand_vector[i_dim] > 1 | < 0");}
        }

         random_shuffle(dimension_permutation.begin(), dimension_permutation.end(), rand_int);

         z_compare zcomp;
         zcomp.DS = data;
         zcomp.z_dimensions = z_dimensions;
         zcomp.precision = precision;

         zcomp.rand_vector = &rand_vector;
         zcomp.dimension_permutation = dimension_permutation;

         std::sort(zindex.begin(), zindex.end(),zcomp);
         g_timer.tuck("END Z-value based sorting2");

         for (int data_i = 0; data_i < data->size; data_i++) {
             zindex_out[data_i] = zindex[data_i];
         }

}


kNNGraph* z_search_sortv(DataSet* data, kNNGraph* knng, int num_curves, int K, int window_width, int z_dimensions) {
    float precision;
    int * zindex;
    DataSet* projDS = data;
    unsigned long long update_count = 0;
    unsigned long long update_count_nndes = 0;
    float update_portion = 0;
    float update_portion_nndes = 0;
    int *rp;
    int *randpoints;
    vector<vector<UINT> > new_knn(data->size);
    vector<vector<UINT> > old_knn(data->size);


    precision = calc_precision(data->dimensionality, z_dimensions, data->elem_min, data->elem_max,1.1);
    zindex = (int*) safemalloc(sizeof(int)*data->size); //TODO: to UINT

    printf("MIN: %f, MAX: %f, precision:%f\n",data->elem_min,data->elem_max,precision);

    g_timer.tuck("START generate rand projection points");
    if(g_options.randp_distance_project > 0) {
         rp = generate_heterogenous_rand_points(data, 500, 100);
    }
    g_timer.tuck("END generate rand projection points");
    fflush(stdout);
    randpoints = rp;
    int proj_dim = z_dimensions;
    int nndes_start_k=g_options.recall_K;
    int nndes_max_k=K;
    int nndes_k=nndes_start_k;
    int run_nndes=0;
    int k_increment=2;

    if(g_options.nndes_K > 0) {
        nndes_max_k = nndes_k = g_options.nndes_K;
    }



    for (int data_i = 0; data_i < data->size; data_i++) {
        zindex[data_i] = data_i;
    }


    for(int i_curve = 0; true ; i_curve++) {
        printf("=====================================================\n");
        g_timer.tuck("START iteration");
        printf("iteration:%d\n",i_curve+1);

        if(g_options.randp_distance_project > 0) {
            g_timer.tuck("randp_distance_project");
            proj_dim = g_options.randp_distance_project;
            projDS = randp_distance_project(knng,data,projDS,i_curve,randpoints,proj_dim);
            find_min_max(projDS);
        }

        if(g_options.randp_distance_project > 0) {

            Stat ** stat = (Stat**) safemalloc(sizeof(Stat*)*proj_dim);
            for(int i=0;i<proj_dim;i++) {stat[i]=init_Stat();} //TODO: fix memory leak

            for(int i_dim=0;i_dim<proj_dim;i_dim++) {
                for(int i_data=0;i_data<projDS->size;i_data++) {
                    float val = get_val(projDS, i_data, i_dim);
                    push_Stat(stat[i_dim],val);
                }
            }

            for(int i_dim=0;i_dim<proj_dim;i_dim++) {
                printf("dim:%d ",i_dim);
                debug_Stat(stat[i_dim]);
            }


            for(int i_dim=0;i_dim<proj_dim;i_dim++) {
                //max 32 bit uint: 4294967295
                //max 32 bit int: 2147483647
                if(stat[i_dim]->mean < -0.2 || stat[i_dim]->mean > 0.2)
                {
                    printf("Mean center data for dim:%d \n",i_dim);
                    mean_center_data(projDS,stat[i_dim],i_dim);
                }
            }
        }


        find_min_max(projDS); //TODO
        generate_z_index_sortv(projDS, proj_dim, zindex, precision);


#ifdef SANITYCHECK
        debug_zindex(projDS,zindex);fflush(stdout);
#endif
        update_count = sliding_window_search(data,knng,zindex,window_width);
        update_portion = ((float)update_count)/((float)(data->size*knng->k)); //TODO:??
        printf("update count: %u (%f\%)\n",update_count,update_portion);

        g_timer.tuck("start calc_recall");
        calculate_recall(knng);

        /*if(i_curve*window_width > K) {*/
        if(g_options.nndes_search && update_portion < g_options.nndes_update_proportion || run_nndes) {
            run_nndes=1;
            g_timer.tuck("start nndes");
            update_count_nndes = nndes_iterate_limited(data,knng,nndes_k);
            update_portion_nndes = ((float)update_count_nndes)/((float)(data->size*K));
            printf("NNDES k=%d update count (nndes): %u (%f\%)\n",nndes_k,update_count_nndes,update_portion);
            calculate_recall(knng);
            /*if(update_portion_nndes < 0.02 && nndes_k < nndes_max_k) {nndes_k++;}*/
            if(nndes_k < nndes_max_k) {nndes_k += k_increment; knng->k += k_increment;}
        }

        printf("update_portion:%f update_portion_nndes:%f g_options.delta:%f\n",update_portion, update_portion_nndes, g_options.delta);
        /*if(update_portion < min_update && update_portion_nndes < min_update) { break;}*/
        g_timer.tuck("END iteration");
        if(update_portion + update_portion_nndes < g_options.delta) { break;}


        //TODO:??
        /*if(g_options.randp_distance_project > 0) {*/
        /*free_DataSet(projDS);*/
        /*randpoints++;*/
        /*}*/

        if(g_options.num_iterations > 0 && (i_curve >= g_options.num_iterations - 1)) {
            printf("Iteration limit reached\n",g_options.num_iterations);
            break;
        }
    }
    return knng;
}


