

#ifndef KNNG_OPTIONS_H
#define KNNG_OPTIONS_H
// Projection types:
#define SJS 1
#define PCA 2

struct options {
    int search_type;
    float rand_scale;
    int out_format;
    int num_threads;
    int num_1dmappings;

    int recall_K;
    int nndes_K;

    int variance_adjust;
    int num_iterations;


    // Dimensionality reduction
    int projection_type;
    int pca_dim;
    int pca_samples;
    int randp_distance_project;

    int stat_adjust;

    // Search types
    bool bruteforce;
    bool priority_search_use_z_graph;
    bool nndes_search;
    float nndes_update_proportion;
    bool priority_search;

    // Optimization
    int partial_distance;

    // Search parameters
    float delta;
    int graph_steps;

    int gt_format;

    int distance_type;
    float minkowski_p;


};

#endif

