#ifndef STAT_H_
#define STAT_H_
struct Stat {
    float mean_old;
    float std_old;
    float mean;
    float std;
    int N;
};

Stat* init_Stat() {
    Stat* stat = (Stat*) safemalloc(sizeof(Stat));
    stat->N=0;
    return stat;
}

float get_std(Stat* stat) {
    return sqrt((stat->std)/(stat->N -1));
}


void debug_Stat(Stat* stat) {
    printf("mean:%f std:%f\n",stat->mean,get_std(stat));

}

void push_Stat(Stat* stat, float x) {
    stat->N++;
    if(stat->N==1) {
        stat->mean_old = stat->mean = x;
        stat->std_old = 0;
    } else {
        stat->mean = stat->mean_old + (x -stat->mean_old)/stat->N;
        stat->std = stat->std_old + (x -stat->mean_old)*(x - stat->mean);
        stat->mean_old = stat->mean;
        stat->std_old = stat->std;
    }
}

#endif
