

/** For reading data from file **/
#include <sstream>
#include <string>
#include <fstream>
#include <sys/time.h>
#include <vector>

#include <float.h>

#include <csignal>

#include <random>

#include <inttypes.h>

#include <boost/format.hpp>
#include <boost/program_options.hpp>
#include <boost/multiprecision/cpp_int.hpp>


#if defined(_OPENMP)
#include <omp.h>
#include <parallel/algorithm>
#endif

#define FLOAT float
#define VECTOR_SIZE  128
//#define COORDINATE_SIZE  8 // Double
#define COORDINATE_SIZE  4 // float
#define ID_SIZE  8 // unsigned long long

//#include "libpqueue/src/pqueue2.h"
//#include "distance.hpp"
#include "options.h"
#include "globals.h"
//struct options g_options;

// Priority queue:
//#define CMPPRI(parent_node,moving_node) parent_node->pri < moving_node->pri
//#include "priority_queue.h"


#define BOOST0 1

#ifdef BOOST0
#define LONG uint1024_t
#define SIZE_LONG 1024
#endif


#ifdef BOOST1
#define LONG uint2048_t
#define SIZE_LONG 2048
#endif

//#define SANITYCHECK 0

// rand float from 0 to 1
#define RAND_FLOAT()  (static_cast <float> (rand()) / static_cast <float> (RAND_MAX))


using namespace boost::multiprecision;
// Needed?:#include <stdio.h>
#include <execinfo.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream>

// For segfault backtrace:
#include <execinfo.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>


using namespace std;
//using namespace boost;
namespace po = boost::program_options;

unsigned long int num_same_edg = 0;
int curves_per_point = 1;
//unsigned long long g_dist_count = 0;

#define ZVALUE 1
//#define ZSORT 1

#define DEBUG 1

#include "zvalue.h"
#include "timer.h"
#include <string>
//unsigned int edit_distance(const std::string& s1, const std::string& s2);
//float dice_distance(const std::string& s1, const std::string& s2);
#include "dataset.h"

#ifdef MAXHEAP
#include "knngraph_heap.h"
#else
#include "knngraph.h"
#endif

#include "nndes.h"

#include "randp_distance_project.h"
kNNGraph* g_ground_truth;
#include "recall.h"
#ifdef LIBPCA
#include "pca_project.h"
#endif


string out_f;
string ground_truth_file;
string input_format;

int ground_truth_K = 20; //TODO
int bruteforce_N = 0; //TODO

//TODO: delete?
// Choose one:
#define SJSSIMPLE 0
#define PCAPROJECT 1
#define JOHNSONLINDENSTRAUS 0

#include "general.h"
#include "brute_force.h"
#include "z_search_arr.h"
#include "construct_knng.h"


// From http://stackoverflow.com/questions/77005/how-to-generate-a-stacktrace-when-my-gcc-c-app-crashes
void handler(int sig) {
    void *array[10];
    size_t size;

    // get void*'s for all entries on the stack
    size = backtrace(array, 10);

    // print out all the frames to stderr
    fprintf(stderr, "Error: signal %d:\n", sig);
    backtrace_symbols_fd(array, size, STDERR_FILENO);
    exit(1);
}


int main (int argc, char *argv[]) {
    srand (time(NULL));

    signal(SIGSEGV, handler);

    int N = 100;//8272885
    int num_curves = 1;
    int num_neighbors = 20;
    int window_width = 100;
    int z_dimensions = 10;
    int search_type = 0;
    int zNN_graph_size = 20;
    int rngSeed = 0;

    unsigned long brute_force_extrapolate_samples = 0;

    kNNGraph* kNN;

    DataSet* DS = NULL;
    DataSet* data = NULL;
    DataSet* DS_proj = NULL; // Dimensionality reduced version of DS

    g_options.num_threads = 1;
    g_options.nndes_search = true;
    g_options.delta = 0.005;
    g_options.nndes_update_proportion = 0.0;


    g_options.pca_dim = 0;
    g_options.pca_samples = 500;


    g_options.variance_adjust = 0;
    g_options.num_iterations = 0;

    g_options.distance_type = 0;
    g_options.minkowski_p = 2; // Euclidean

    g_options.stat_adjust = 0;
    g_options.partial_distance = false;
    g_options.graph_steps = 100;


    g_options.gt_format = RANDOM_SAMPLED_BRUTEFORCE;
    //g_options.nndes_search = false;


    // Declare the supported options.
    po::options_description desc("Allowed options");
    desc.add_options()
        ("help", "produce help message")
        ("zorderstat", "Calculate statistics (Q-value) for z-order")
        ("num_curves,C", po::value<int>(&num_curves)->default_value(1),
         "num")
        ("num_neighbors,k", po::value<int>(&num_neighbors)->default_value(1),
         "num")
        ("search_type", po::value<int>(&search_type)->default_value(0),
         //"0 = zgraph, 1 = z_array_graph")
        "0 = zordersearch, 1 = kdtree")
            ("z_dimensions,h", po::value<int>(&z_dimensions)->default_value(10),
             "")

            ("pca", po::value<int>(&g_options.pca_dim)->default_value(0),
             "")
            ("seed", po::value<int>(&rngSeed)->default_value(0),
             "Random number seed, 0=init from time")

            ("pca_samples", po::value<int>(&g_options.pca_samples)->default_value(10000),
             "")
            ("graph_steps", po::value<int>(&g_options.graph_steps)->default_value(g_options.graph_steps),
             "")
            ("delta", po::value<float>(&g_options.delta)->default_value(g_options.delta),
             "")
            ("dist", po::value<int>(&g_options.distance_type)->default_value(g_options.distance_type),
             "Distance type (0=euclidean,1=minkowski")
            (",p", po::value<float>(&g_options.minkowski_p)->default_value(g_options.minkowski_p),
             "Minkowski distance p parameter")

            (",I", po::value<int>(&g_options.num_iterations)->default_value(g_options.num_iterations),
             "Limit number of iterations.")
            ("nndesstart", po::value<float>(&g_options.nndes_update_proportion)->default_value(0),
             "")

            ("randproj", po::value<int>(&g_options.randp_distance_project)->default_value(0), "(experimental)")
            ("partial_distance", po::value<int>(&g_options.partial_distance)->default_value(0), "")
            ("recall_K", po::value<int>(&g_options.recall_K)->default_value(0), "")
            ("nndes_K", po::value<int>(&g_options.nndes_K)->default_value(0), "")
            ("rand_scale", po::value<float>(&g_rand_scale)->default_value(g_rand_scale),
             "")
#if defined(_OPENMP)
            ("threads", po::value<int>(&g_options.num_threads)->default_value(g_options.num_threads),
             "")
#endif

            ("bruteforce", po::value<int>(&bruteforce_N)->default_value(bruteforce_N),
             "Brute force results")

            ("bf_extrap", po::value<unsigned long>(&brute_force_extrapolate_samples)->default_value(0),
             "Extrapolate brute force single core running time")


            ("window_width,W", po::value<int>(&window_width)->default_value(100),
             "num")
            ("znngraphsize,Z", po::value<int>(&zNN_graph_size)->default_value(zNN_graph_size),
             "num")

            ("out,o", po::value<string>(&out_f),
             "output kNN file name")
            ("groundtruth", po::value<string>(&ground_truth_file),
             "Ground truth file to verify results.")
            ("gt_format", po::value<int>(&g_options.gt_format)->default_value(g_options.gt_format), "")

            ("format,f", po::value<string>(&input_format),
             "")

            //("out,o", po::value< vector<string> >(), "output file")

            ("N", po::value<int>(&N), "max data size")
            ;

    po::variables_map vm;
    po::store(po::parse_command_line(argc, argv, desc), vm);
    po::notify(vm);

    if(g_options.recall_K <= 0) {g_options.recall_K =num_neighbors;}
    if(rngSeed > 0) { srand (rngSeed);}

    printf("PARAMS: graph_K=%d recall_K=%d  delta=%f W=%d distance_type=%d p=%f\n",num_neighbors,g_options.recall_K,g_options.delta,
            window_width, g_options.distance_type,g_options.minkowski_p);

#if defined(_OPENMP)
    printf("OPENMP Multithreading: YES\n");
    omp_set_num_threads(g_options.num_threads);

    printf("Num threads:%d\n",omp_get_num_threads());
#else
    printf("OPENMP Multithreading: NO\n");
#endif


    cout << "out: " << out_f.c_str() <<endl;
    //return 0;

    if (vm.count("help")) {
        cout << desc << "\n";
        return 1;
    }


    if (input_format == "ascii") {
        DS = read_ascii_dataset(argv[1]);
    }
    else {
        DS = read_lshkit(argv[1]);
    }
    data = DS;
    printf(" DONE\n");fflush(stdout);


    kNNGraph* ground_truth = NULL;
    g_ground_truth = NULL;
    if(ground_truth_file.size() > 0) {
        printf("Loading ground truth file: %s\n", ground_truth_file.c_str());

        ground_truth = load_kNN_ivec(ground_truth_file, RANDOM_SAMPLED_BRUTEFORCE);

        recalc_dist(ground_truth,data);
        g_ground_truth = ground_truth;
        printf("LOADED\n");
    }

    // Start counting time
    g_timer.tick();

    g_options.projection_type = SJS;

    // TODO?:
    if (vm.count("zorderstat")) {
        calc_z_order_stat( data, NULL,  num_curves, num_neighbors, window_width, z_dimensions);
        return 1;
    }



    if(brute_force_extrapolate_samples > 0) {
        brute_force_extrapolate(DS, brute_force_extrapolate_samples, num_neighbors);
        return 0;
    }


    if(bruteforce_N != 0) {
        if(bruteforce_N == DS->size) {
            kNN = brute_force_search(DS,bruteforce_N, num_neighbors);
        }
        //TODO:
        //else if(bruteforce_N < DS->size && bruteforce_N > 0) {
        //kNN = random_sampled_brute_force_search(DS,bruteforce_N, num_neighbors);
        //}
        else {
            terminal_error("Invalid bruteforce parameter.");
        }
        write_kNN_ivec(out_f,kNN,0); //TODO??
    }
    else {

        if (search_type==0) {
            // Construct z-order by using lookup tables (default, fast).
            kNN = construct_knng (data, DS_proj, num_curves, num_neighbors, window_width, z_dimensions, zNN_graph_size, ground_truth,1);
        }

        else if (search_type==50) {
            // Use z-order sorting instead of calculating full z-values.
            kNN = construct_knng (data, DS_proj, num_curves, num_neighbors, window_width, z_dimensions, zNN_graph_size, ground_truth,0);
        }
        else {
            terminal_error("Invalid search_type.");
        }

        if(kNN && !out_f.empty()) {
            write_kNN_ivec(out_f,kNN,0); //TODO??
        }
    }

    if(DS) { free_DataSet(DS); }
    if(kNN) { free_kNNGraph(kNN); }

    return 0;
}

